------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
private with Ada.Finalization;
with Qt4.Bitmaps;
with Qt4.Pixmaps;
with Qt4.Points;
private with Qt_Ada.Internals.Value_Class_Sizes;

package Qt4.Cursors is

   type Q_Cursor is tagged private;

   function Create
    (Shape : Qt4.Cursor_Shape)
       return Q_Cursor;

   function Create
    (Bitmap : Qt4.Bitmaps.Q_Bitmap'Class;
     Mask : Qt4.Bitmaps.Q_Bitmap'Class;
     Hot_X : Qt4.Q_Integer
       := -1;
     Hot_Y : Qt4.Q_Integer
       := -1)
       return Q_Cursor;

   function Create
    (Pixmap : Qt4.Pixmaps.Q_Pixmap'Class;
     Hot_X : Qt4.Q_Integer
       := -1;
     Hot_Y : Qt4.Q_Integer
       := -1)
       return Q_Cursor;

   function Bitmap
    (Self : Q_Cursor'Class)
       return Qt4.Bitmaps.Q_Bitmap;

   function Hot_Spot
    (Self : Q_Cursor'Class)
       return Qt4.Points.Q_Point;

   function Mask
    (Self : Q_Cursor'Class)
       return Qt4.Bitmaps.Q_Bitmap;

   function Pixmap
    (Self : Q_Cursor'Class)
       return Qt4.Pixmaps.Q_Pixmap;

   procedure Set_Shape
    (Self : in out Q_Cursor'Class;
     Shape : Qt4.Cursor_Shape);

   function Shape
    (Self : Q_Cursor'Class)
       return Qt4.Cursor_Shape;

   function Pos
     return Qt4.Points.Q_Point;

   procedure Set_Pos
    (X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer);

   procedure Set_Pos
    (P : Qt4.Points.Q_Point'Class);

   package Internals is

      type QCursor is private;

      type QCursor_Access is access all QCursor;
      pragma Convention (C, QCursor_Access);

      function QCursor_View
       (Item : Q_Cursor'Class)
          return QCursor_Access;
      pragma Inline (QCursor_View);

      function To_Pointer
       (Address : System.Address)
          return QCursor_Access;
      pragma Inline (To_Pointer);

      function To_Address
       (Pointer : QCursor_Access)
          return System.Address;
      pragma Inline (To_Address);

      function Create_Wrapper
       (Item : Internals.QCursor_Access)
          return Q_Cursor;

   private

      type QCursor is record
         Placeholder : Interfaces.C.char_array (1 .. Qt_Ada.Internals.Value_Class_Sizes.QCursor_C_Size_Of);
      end record;
      pragma Convention (C, QCursor);

   end Internals;

private

   type Q_Cursor is new Ada.Finalization.Controlled with record
      Storage : aliased Internals.QCursor;
      Object  : Internals.QCursor_Access := null;
      Wrapper : Boolean := False;
   end record;

   overriding
   procedure Adjust (Self : in out Q_Cursor);

   overriding
   procedure Finalize (Self : in out Q_Cursor);

   overriding
   procedure Initialize (Self : in out Q_Cursor);

end Qt4.Cursors;
